// another fine solution by misof
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

int R, S, P=1000000009;
vector< vector<pair<int,int> > > vstupy;
#include <tr1/unordered_map>
tr1::unordered_map< long long, int > C;

#define ENCODE2(x,y) ( ((long long)(x) << 30) + (y) )
#define ENCODE(p) ENCODE2(p.first,p.second)

void load() {
  int N;
  scanf("%d%d%d",&R,&S,&N);
  vstupy.resize(N);
  for (int n=0; n<N; ++n) {
    int K;
    scanf("%d",&K);
    while (K--) { 
      int x,y; 
      scanf("%d%d",&x,&y); 
      vstupy[n].push_back( make_pair(x,y) );
    }
  }
}

int comb[2][123456];

void precompute() {
  vector< pair<int,int> > potrebujem;
  potrebujem.push_back(make_pair(R,S));
  for (int n=0; n<int(vstupy.size()); ++n) 
    for (int k=0; k<int(vstupy[n].size()); ++k)
      potrebujem.push_back( vstupy[n][k] );
  for (int n=0; n<int(vstupy.size()); ++n) 
    for (int k=0; k<int(vstupy[n].size()); ++k)
      potrebujem.push_back( make_pair(R-vstupy[n][k].first, S-vstupy[n][k].second) );
  for (int n=0; n<int(vstupy.size()); ++n) 
    for (int k=0; k<int(vstupy[n].size()); ++k)
      for (int l=0; l<int(vstupy[n].size()); ++l) if (k!=l) {
        int dr = vstupy[n][k].first - vstupy[n][l].first;
        int ds = vstupy[n][k].second - vstupy[n][l].second;
        if (dr >= 0 && ds >= 0) potrebujem.push_back( make_pair(dr,ds) );
      }
  potrebujem.push_back( make_pair(R+1,S+1) );
  sort( potrebujem.begin(), potrebujem.end() );
  typeof potrebujem.begin() it = unique( potrebujem.begin(), potrebujem.end() );
  potrebujem.resize( it - potrebujem.begin() );
  int p = 0;

  for (int r=0; r<=R; ++r) {
    int cur=r%2, prev=1-cur;
    if (r==0) for (int s=0; s<=S; ++s) comb[cur][s]=1; else {
      comb[cur][0]=1;
      for (int s=1; s<=S; ++s) {
        comb[cur][s] = comb[prev][s] + comb[cur][s-1];
        if (comb[cur][s] > P) comb[cur][s] -= P;
      }
    }
    while (potrebujem[p].first==r) {
      C[ ENCODE(potrebujem[p]) ] = comb[cur][potrebujem[p].second];
      ++p;
    }
  }
}

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  load();
  precompute();
  for (int n=0; n<int(vstupy.size()); ++n) {
    vector< pair<int,int> > prekazky = vstupy[n];
    prekazky.push_back( make_pair(R,S) );
    sort( prekazky.begin(), prekazky.end(), distless );
    int K = prekazky.size()-1;
    vector<long long> G(K+1);
    for (int k=0; k<=K; ++k) G[k] = C[ ENCODE2(prekazky[k].first,prekazky[k].second) ];
    for (int k=0; k<K; ++k)
      for (int l=k+1; l<=K; ++l)
        if (prekazky[l].first >= prekazky[k].first && prekazky[l].second >= prekazky[k].second) {
          G[l] -= G[k] * C[ ENCODE2( prekazky[l].first - prekazky[k].first, prekazky[l].second - prekazky[k].second ) ];
          G[l] %= P;
          if (G[l] < 0) G[l] += P;
        }
    cout << G[K] << endl;
  }
}
